VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMP3Player"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Basiert auf:
'
' Class clsTrickMP3Player.cls - for asynchronous play mp3-files from memory.
'  Krivous Anatolii Anatolevich (The trick), 2015
' Version 1.1
'
' alles unwichtige aus dem Originalcode fr dieses Projekt entfernt!

Option Explicit

' ----==== Const ====----
Private Const WAVE_MAPPER As Long = -1&
Private Const WHDR_DONE As Long = &H1&
Private Const CALLBACK_NULL As Long = &H0&
Private Const MPEGLAYER3_FLAG_PADDING_OFF As Long = &H2&
Private Const WAVE_FORMAT_MPEGLAYER3 As Long = &H55&
Private Const MPEGLAYER3_WFX_EXTRA_BYTES As Long = &HC&
Private Const MPEGLAYER3_ID_MPEG As Long = &H1&
Private Const BUFFERS_COUNT As Long = &H8&
Private Const MMSYSERR_NOERROR As Long = &H0&

Private Type MPEGLAYER3WAVEFORMAT
    wFormatTag As Integer
    nChannels As Integer
    nSamplesPerSec As Long
    nAvgBytesPerSec As Long
    nBlockAlign As Integer
    wBitsPerSample As Integer
    cbSize As Integer
    wID As Integer
    fdwFlags As Long
    nBlockSize As Integer
    nFramesPerBlock As Integer
    nCodecDelay As Integer
End Type

Private Type FRAMEINFO
    Offset As Long
    Bitrate As Long
End Type

Private Type WAVEHDR
    lpData As Long
    dwBufferLength As Long
    dwBytesRecorded As Long
    dwUser As Long
    dwFlags As Long
    dwLoops As Long
    lpNext As Long
    reserved As Long
End Type

Private Type MP3INFO
    format As MPEGLAYER3WAVEFORMAT
    lpFrameOffset As Long
    szDataSize As Long
    SamplesPerFrame As Long
    FramesCount As Long
    FrameOffset() As FRAMEINFO
End Type

Private Type MP3BUFFER
    Header As WAVEHDR
    Status As Boolean
End Type

Private Type MP3CONST
    Bitrate(0 To 1, 0 To 15) As Integer
    Samplerate(0 To 2, 0 To 3) As Long
End Type


' ----==== Kernel32 API-Deklarationen ====----
Private Declare Sub CopyMemory Lib "kernel32.dll" _
                    Alias "RtlMoveMemory" ( _
                    ByRef Destination As Any, _
                    ByRef Source As Any, _
                    ByVal Length As Long)

' ----==== Oleaut32.dll ====----
Private Declare Function SafeArrayGetDim Lib "oleaut32.dll" ( _
                         ByRef pArray() As Any) As Long

' ----==== Winmm API-Deklarationen ====----
Private Declare Function waveOutOpen Lib "winmm.dll" ( _
                         ByRef lphWaveOut As Long, _
                         ByVal uDeviceID As Long, _
                         ByRef lpFormat As Any, _
                         ByVal dwCallback As Long, _
                         ByVal dwInstance As Long, _
                         ByVal dwFlags As Long) As Long

Private Declare Function waveOutPrepareHeader Lib "winmm.dll" ( _
                         ByVal hWaveOut As Long, _
                         ByRef lpWaveOutHdr As WAVEHDR, _
                         ByVal uSize As Long) As Long

Private Declare Function waveOutWrite Lib "winmm.dll" ( _
                         ByVal hWaveOut As Long, _
                         ByRef lpWaveOutHdr As WAVEHDR, _
                         ByVal uSize As Long) As Long

Private Declare Function waveOutUnprepareHeader Lib "winmm.dll" ( _
                         ByVal hWaveOut As Long, _
                         ByRef lpWaveOutHdr As WAVEHDR, _
                         ByVal uSize As Long) As Long

Private Declare Function waveOutClose Lib "winmm.dll" ( _
                         ByVal hWaveOut As Long) As Long

Private Declare Function waveOutReset Lib "winmm.dll" ( _
                         ByVal hWaveOut As Long) As Long

Private Declare Function waveOutPause Lib "winmm.dll" ( _
                         ByVal hWaveOut As Long) As Long

Private Declare Function waveOutRestart Lib "winmm.dll" ( _
                         ByVal hWaveOut As Long) As Long

' ----==== Vars ====----
Private m_hWave As Long
Private m_CurPosition As Long
Private m_Buffer() As Byte
Private m_Loaded As Boolean
Private m_Playing As Boolean
Private m_Paused As Boolean
Private m_MP3I As MP3INFO
Private m_MP3C As MP3CONST
Private m_MP3B() As MP3BUFFER

Public Sub TimerTick()

    Dim lItem As Long

    If m_Loaded = True Then

        If m_Playing = True Then

            For lItem = 0 To BUFFERS_COUNT - 1

                If (m_MP3B(lItem).Header.dwFlags And WHDR_DONE) = WHDR_DONE Then

                    Call WriteNext(lItem)

                End If

            Next

        End If

    End If

End Sub

Private Sub WriteNext(ByVal index As Long)

    If m_hWave <> 0& Then
        
        If waveOutUnprepareHeader(m_hWave, m_MP3B(index).Header, Len(m_MP3B( _
            index).Header)) = MMSYSERR_NOERROR Then

            If m_Playing = True Then

                If m_CurPosition <> -1 Then

                    m_MP3B(index).Header.dwFlags = m_MP3B(index).Header.dwFlags _
                        And Not WHDR_DONE

                    m_MP3B(index).Header.lpData = m_MP3I.lpFrameOffset + _
                        m_MP3I.FrameOffset(m_CurPosition).Offset

                    If m_CurPosition < m_MP3I.FramesCount - 1 Then

                        m_MP3B(index).Header.dwBufferLength = m_MP3I.FrameOffset( _
                            m_CurPosition + 1).Offset - m_MP3I.FrameOffset( _
                            m_CurPosition).Offset

                        m_CurPosition = m_CurPosition + 1

                    Else

                        m_MP3B(index).Header.dwBufferLength = m_MP3I.szDataSize - _
                            m_MP3I.FrameOffset(m_CurPosition).Offset
                            
                        m_CurPosition = -1

                    End If

                    If waveOutPrepareHeader(m_hWave, m_MP3B(index).Header, Len( _
                        m_MP3B(index).Header)) = MMSYSERR_NOERROR Then

                        Call waveOutWrite(m_hWave, m_MP3B(index).Header, Len( _
                            m_MP3B(index).Header))

                    End If
                    
                Else
                        
                    m_Paused = False
                    m_Playing = False
                    m_CurPosition = -1
                    Call waveOutReset(m_hWave)
                    
                End If

            End If

        End If

    End If

End Sub

Private Function InitPlay() As Boolean

    Dim bRet As Boolean
    Dim lRet As Long
    Dim lItem As Long

    bRet = False

    If m_hWave <> 0& Then
    
        If m_CurPosition < 0 Then m_CurPosition = 0

        For lItem = 0 To BUFFERS_COUNT - 1

            m_MP3B(lItem).Header.lpData = m_MP3I.lpFrameOffset + _
                m_MP3I.FrameOffset(m_CurPosition).Offset

            If lItem < m_MP3I.FramesCount - 1 Then

                m_MP3B(lItem).Header.dwBufferLength = m_MP3I.FrameOffset( _
                    m_CurPosition + 1).Offset - m_MP3I.FrameOffset( _
                    m_CurPosition).Offset

            Else

                m_MP3B(lItem).Header.dwBufferLength = m_MP3I.szDataSize - _
                    m_MP3I.FrameOffset(m_CurPosition).Offset
                    
                Exit For

            End If

            If waveOutPrepareHeader(m_hWave, m_MP3B(lItem).Header, Len(m_MP3B( _
                lItem).Header)) = MMSYSERR_NOERROR Then

                m_MP3B(lItem).Status = True

                If waveOutWrite(m_hWave, m_MP3B(lItem).Header, Len(m_MP3B( _
                    lItem).Header)) = MMSYSERR_NOERROR Then

                    m_CurPosition = m_CurPosition + 1
                    bRet = True

                Else

                    bRet = False
                    Call ClearMp3Data

                End If

            Else
                
                bRet = False
                m_MP3B(lItem).Status = False
                Call ClearMp3Data

            End If

        Next

    End If

    InitPlay = bRet

End Function

Public Function StartPlaying() As Boolean

    Dim bRet As Boolean
    
    bRet = False

    If m_Loaded = True Then

        If m_Paused = True Then

            If m_hWave <> 0& Then

                If waveOutRestart(m_hWave) = MMSYSERR_NOERROR Then

                    m_Paused = False

                End If

            End If

        Else

            If m_Playing = False Then
            
                If InitPlay = True Then

                    bRet = True
                    m_Playing = True

                End If

            End If

        End If

    End If

    StartPlaying = bRet

End Function

Public Function PausePlaying() As Boolean

    Dim bRet As Boolean

    bRet = False

    If m_Loaded = True Then

        If m_hWave <> 0& Then
        
            If waveOutPause(m_hWave) = MMSYSERR_NOERROR Then

                bRet = True
                m_Paused = True

            End If

        End If

    End If

    PausePlaying = bRet

End Function

Public Function StopPlaying() As Boolean

    Dim lItem As Long
    Dim bRet As Boolean

    bRet = False

    If m_Loaded = True Then

        m_Paused = False
        m_Playing = False
        m_CurPosition = -1

        If m_hWave <> 0& Then
            
            If waveOutReset(m_hWave) = MMSYSERR_NOERROR Then

                bRet = True

            End If
        
        End If
    
    End If

    StopPlaying = bRet

End Function

Public Function LoadMp3Data(ByVal sMP3 As String) As Boolean
    
    Call ClearMp3Data
    
    LoadMp3Data = InitMp3Data(StrConv(sMP3, vbFromUnicode))

End Function

Private Function InitMp3Data(ByRef bMp3Data() As Byte) As Boolean

    Dim bRet As Boolean
    Dim tMP3I As MP3INFO

    bRet = False
    m_Playing = False
    m_Paused = False
    m_Loaded = False
    
    If SafeArrayGetDim(bMp3Data) <> 0& Then

        If GetMp3Info(bMp3Data, tMP3I) = True Then

            If m_hWave <> 0& Then

                Call ClearMp3Data

            End If

            ReDim m_Buffer(tMP3I.szDataSize - 1)

            Call CopyMemory(m_Buffer(0), ByVal tMP3I.lpFrameOffset, _
                tMP3I.szDataSize)

            tMP3I.lpFrameOffset = VarPtr(m_Buffer(0))

            If waveOutOpen(m_hWave, WAVE_MAPPER, tMP3I.format, 0&, 0&, _
                CALLBACK_NULL) = MMSYSERR_NOERROR Then

                m_MP3I = tMP3I
                m_CurPosition = 0&
                m_Loaded = True

                bRet = True

            Else

                m_CurPosition = 0&
                m_hWave = 0&

            End If

        End If

    End If

    InitMp3Data = bRet

End Function

Public Sub ClearMp3Data()

    Dim lItem As Long

    m_Playing = False
    m_Paused = False
    m_Loaded = False
    m_CurPosition = 0&

    If m_hWave <> 0& Then

        For lItem = 0 To BUFFERS_COUNT - 1

            If m_MP3B(lItem).Status = True Then
            
                Call waveOutUnprepareHeader(m_hWave, m_MP3B(lItem).Header, Len(m_MP3B( _
                    lItem).Header))
                
            End If

        Next

        Call waveOutReset(m_hWave)
        
        Call waveOutClose(m_hWave)

    End If

    m_hWave = 0&

End Sub

Private Function GetMp3Info(ByRef bMp3Data() As Byte, ByRef info As MP3INFO) As Boolean

    Dim bHeader(9) As Byte
    Dim lSize As Long
    Dim lpData As Long
    Dim szData As Long

    lpData = VarPtr(bMp3Data(0))
    szData = UBound(bMp3Data) + 1

    If szData >= 128 Then

        ' Skip ID3V1 tag
        CopyMemory bHeader(0), ByVal lpData + szData - 128, 3

        If bHeader(0) = &H54 And bHeader(1) = &H41 And bHeader(2) = &H47 Then

            szData = szData - 128

        End If

    End If

    ' Skip ID3V2 tags from beginning
    CopyMemory bHeader(0), ByVal lpData, 10

    If bHeader(0) = &H49 And bHeader(1) = &H44 And bHeader(2) = &H33 Then

        ' footer present
        If bHeader(5) And &H10 Then

            szData = szData - 10

        End If

        lSize = bHeader(6) * &H200000
        lSize = lSize Or (bHeader(7) * &H4000&)
        lSize = lSize Or (bHeader(8) * &H80&)
        lSize = lSize Or bHeader(9)
        lSize = lSize + 10

        lpData = lpData + lSize
        szData = szData - lSize

    Else

        ' Skip ID3V2 tags from end
        CopyMemory bHeader(0), ByVal lpData + szData - 10, 10

        If bHeader(2) = &H49 And bHeader(1) = &H44 And bHeader(0) = &H33 Then

            szData = szData - 10

            lSize = bHeader(6) * &H200000
            lSize = lSize Or (bHeader(7) * &H4000&)
            lSize = lSize Or (bHeader(8) * &H80&)
            lSize = lSize Or bHeader(9)
            lSize = lSize + 10

            szData = szData - lSize

        End If

    End If

    If szData < 4 Then Exit Function

    info.FramesCount = 0

    ' Scan headers
    Do

        ' Find a frame sync
        Do

            CopyMemory bHeader(0), ByVal lpData, 4

            If bHeader(0) = &HFF And (bHeader(1) And &HE0) = &HE0 Then

                Dim vers    As Long
                Dim layer   As Long
                Dim Bitrate As Long
                Dim Samplerate As Long
                Dim padding As Long
                Dim channel As Long

                vers = (bHeader(1) And &H18) \ 8

                If vers = 1 Then Exit Function

                layer = (bHeader(1) And &H6) \ 2

                ' Only Layer 3
                If layer <> 1 Then Exit Function

                If vers = 3 Then

                    Bitrate = m_MP3C.Bitrate(0, (bHeader(2) And &HF0) \ &H10)

                Else

                    Bitrate = m_MP3C.Bitrate(1, (bHeader(2) And &HF0) \ &H10)

                End If

                If vers = 3 Then

                    Samplerate = m_MP3C.Samplerate(0, (bHeader(2) And &HC) \ &H4)

                ElseIf vers = 2 Then

                    Samplerate = m_MP3C.Samplerate(1, (bHeader(2) And &HC) \ &H4)

                Else

                    Samplerate = m_MP3C.Samplerate(2, (bHeader(2) And &HC) \ &H4)

                End If

                padding = (bHeader(2) And &H2) \ 2
                channel = -(((bHeader(3) And &HC0) \ 64) <> 3) + 1

                If vers = 3 Then

                    lSize = Int(144000 * Bitrate / Samplerate) + padding

                Else

                    lSize = Int(72000 * Bitrate / Samplerate) + padding

                End If

                With info

                    If .FramesCount = 0 Then

                        With .format

                            .wFormatTag = WAVE_FORMAT_MPEGLAYER3
                            .cbSize = MPEGLAYER3_WFX_EXTRA_BYTES
                            .nChannels = channel
                            .nAvgBytesPerSec = Bitrate * 128
                            .wBitsPerSample = 0
                            .nBlockAlign = 1
                            .nSamplesPerSec = Samplerate
                            .nFramesPerBlock = 1
                            .nCodecDelay = 0
                            .fdwFlags = MPEGLAYER3_FLAG_PADDING_OFF
                            .wID = MPEGLAYER3_ID_MPEG
                            .nBlockSize = lSize

                        End With

                        .lpFrameOffset = lpData
                        .szDataSize = szData

                        If vers = 3 Then

                            .SamplesPerFrame = 1152

                        Else

                            .SamplesPerFrame = 576

                        End If

                        ReDim .FrameOffset(511)

                    Else

                        If UBound(.FrameOffset) = info.FramesCount Then

                            ReDim Preserve .FrameOffset(UBound(.FrameOffset) + 512)

                        End If

                    End If

                    .FrameOffset(info.FramesCount).Offset = lpData - .lpFrameOffset
                    .FrameOffset(info.FramesCount).Bitrate = Bitrate

                End With

                lpData = lpData + lSize
                szData = szData - lSize

                Exit Do

            End If

            lpData = lpData + 1
            szData = szData - 1

        Loop While szData >= 4

        info.FramesCount = info.FramesCount + 1

    Loop While szData >= 4

    GetMp3Info = True

End Function

Public Property Get IsPlaying() As Boolean

    Dim bRet As Boolean

    bRet = False

    If m_Loaded = True Then
        If m_Playing = True Then
            If m_Paused = False Then

                bRet = True

            End If
        End If
    End If

    IsPlaying = bRet

End Property

Public Property Get IsPaused() As Boolean

    Dim bRet As Boolean

    bRet = False

    If m_Loaded = True Then
        If m_Playing = True Then
            If m_Paused = True Then

                bRet = True

            End If
        End If
    End If

    IsPaused = bRet

End Property

Public Property Get IsStopped() As Boolean

    Dim bRet As Boolean

    bRet = False

    If m_Loaded = True Then
        If m_Playing = False Then
            If m_Paused = False Then

                bRet = True

            End If
        End If
    End If

    IsStopped = bRet

End Property

Private Sub Class_Initialize()
    
    Dim curBitrates(15) As Currency
    
    curBitrates(0) = 450377142658.6656@:    curBitrates(1) = 900743977448.248@:     curBitrates(2) = 1351114248211.6672@
    curBitrates(3) = 1801487954948.9248@:   curBitrates(4) = 2702228496423.3344@:   curBitrates(5) = 3602975909897.8496@
    curBitrates(6) = 4503737067267.712@:    curBitrates(7) = 18941235272.0895@:     curBitrates(8) = 4735201446.045@
    curBitrates(9) = 10307921515.2@:        curBitrates(10) = 13743895348.4@:       curBitrates(11) = 3435973838.4@

    Call CopyMemory(m_MP3C.Bitrate(0, 1), curBitrates(0), 96)

    ReDim m_MP3B(BUFFERS_COUNT - 1)
    
    m_Playing = False
    m_Paused = False
    m_Loaded = False
    m_CurPosition = 0&
    m_hWave = 0&
    
End Sub

Private Sub Class_Terminate()

    Call ClearMp3Data
    
End Sub
